# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.


from PyQt4.QtCore import *
from PyQt4.QtGui import *

from chrome import GwStdSvgItem
from generic.widget import GwWidget

from items.rectitem import GwRectItem

from layout import GwHBoxLayout

from textlabel import GwTextLabel


class GwCheckbox(GwWidget):
	toggledSig = pyqtSignal(bool)
	
	def __init__(self, text=None, parent=None):
		GwWidget.__init__(self, parent)
		self.construct(text)
		
		
	def construct(self, text):
		self.isChecked = False
		
		self.setFixedSize(QSizeF(22,22))
		self.icon = GwStdSvgItem('check-off.svg', 12, 12, self)
		self.icon.setPos(6,4)
		
		self.textItem = None
		if text and len(text)>0:
			self.textItem = QGraphicsSimpleTextItem(text, self)
			self.textItem.setPos(20, 2)
			self.setFixedWidth(self.textItem.boundingRect().width()+24)
		
		
	def setEnabled(self, val):
		if self.isEnabled() == val:
			return
			
		if val==True:
			self.disabledVeil.scene().removeItem(self.disabledVeil)
			self.disabledVeil = None
		else:
			self.disabledVeil = GwRectItem(self)
			#self.disabledVeil.setFlag(QGraphicsItem.ItemIgnoresParentOpacity)
			self.disabledVeil.setRect(2,2,self.w()-4,self.h()-4)
			self.disabledVeil.setColor(QColor(190,190,190))
			self.disabledVeil.setOpacity(0.8)
		
		QGraphicsWidget.setEnabled(self, val)
	
	
	#def hoverEnterEvent(self, event):
		#self.focusFrame.show()
		
	#def hoverLeaveEvent(self, event):
		#self.focusFrame.hide()

			
	def resizeEvent(self, ev):
		if not self.isEnabled():
			self.disabledVeil.resize(self.w()-4,self.h()-4)
		
	
	def mousePressEvent(self,ev):
		if ev.button() == Qt.RightButton:
			ev.ignore()
		
		
	def mouseReleaseEvent(self, ev):
		self.setState(not self.isChecked)


	def setState(self, isChecked):
		if self.isChecked == isChecked:
			return
		self.icon.deleteLater()
		if self.isChecked:
			self.icon =  GwStdSvgItem('check-off.svg', 12, 12, self)
		else:
			self.icon = GwStdSvgItem('check-on.svg', 12, 12, self)
		self.icon.setPos(6,4)
		self.isChecked = not(self.isChecked)
		self.toggledSig.emit(self.isChecked)
		
