# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.


from PyQt4.QtCore import *
from PyQt4.QtGui import *

from generic.widget import GwWidget

class GwClipBox(GwWidget):
	sizesChangedSig = pyqtSignal()

	def __init__(self, parent=None):
		GwWidget.__init__(self, parent)
		self.content = None
		self.setFlag(QGraphicsItem.ItemClipsChildrenToShape, True)
		#self.setHandlesChildEvents(True)
		
	
	def dSize(self):
		if self.content:
			dw = self.content.size().width() - self.size().width()
			dh = self.content.size().height() - self.size().height()
			return (dw,dh)
		else:
			return (0,0)
			
	
	def resizeEvent(self, ev):
		#print 'emit', ev.oldSize(), ev.newSize()
		self.sizesChangedSig.emit()
	
	
	def eventFilter(self, obj, ev):
		if ev.type() == QEvent.GraphicsSceneResize:
			self.sizesChangedSig.emit()
		return False
		
		
	def setContent(self, content):
		content.setParentItem(self)
		content.installEventFilter(self)
		self.content = content
		self.sizesChangedSig.emit()
	
		
	#def itemChange(self,change,val):
		#if change == QGraphicsItem.ItemChildAddedChange:
			#print 'ClippingArea: child added ',val.toPyObject()
			#self.content = val.toPyObject()
			 
			 
class GwVClipBox(GwClipBox):
	def resizeEvent(self, ev):
		if self.content:
			self.content.resize(ev.newSize().width(), self.content.size().height())
		GwClipBox.resizeEvent(self, ev)
		#print 'content', self.content.size()
		
		