# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from generic.widget import GwWidget
from chrome import GwStdFrameItem
from items.rectitem import GwRectItem


class GwFrame(GwWidget):
	def __init__(self, parent=None):
		GwWidget.__init__(self, parent)
		self.setContentsMargins(3,3,3,3)
		
		self.frameItem = GwStdFrameItem('frame-white.svg', prefix='plain-', parent=self)
		
		
	def setFrameStyle(self, style, subStyle=None):
		self.frameItem.deleteLater()
		if style == 'none':
			self.frameItem = GwRectItem(parent=self)
			self.frameItem.setOpacity(0)
		elif style == 'box':
			self.frameItem = GwRectItem(parent=self)
		else:
			self.frameItem = GwStdFrameItem('frame-'+style+'.svg', prefix=subStyle+'-', parent=self)
		self.frameItem.resize(self.size().width(), self.size().height())
		
		
	def resizeEvent(self, ev):
		if self.w()>1 and self.h()>1:
			self.frameItem.resize(self.w()-1, self.h()-1) 

