# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.

 
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from ..delayedcall import delayedCall

class CommonWidget:
	def setFixedSize(self, size):
		self.setMinimumSize(size)
		self.setMaximumSize(size)
		
	def setFixedWidth(self, width):
		self.setMinimumWidth(width)
		self.setMaximumWidth(width)
		
	def setFixedHeight(self, height):
		self.setMinimumHeight(height)
		self.setMaximumHeight(height)
		
	def setEqualSizeHints(self, widget):
		self.setMinimumSize(widget.minimumSize())
		self.setMaximumSize(widget.maximumSize())
		self.setPreferredSize(widget.preferredSize())
		
	def w(self):
		return self.size().width()
		
	def h(self):
		return self.size().height()
		
	def delFromScene(self):
		if self.scene():
			delayedCall(10, self.scene().removeItem(self))



class GwWidget(QGraphicsWidget, CommonWidget):
	def __init__(self, parent=None):
		QGraphicsWidget.__init__(self, parent)



class GwMinSizeWidget(GwWidget):
	def event(self,ev):
		if ev.type() == QEvent.LayoutRequest:
			self.resize(self.layout().minimumSize())
		return GwWidget.event(self,ev)



class GwPrefSizeWidget(GwWidget):
	def event(self,ev):
		if ev.type() == QEvent.LayoutRequest:
			self.resize(self.layout().preferredSize())
		return GwWidget.event(self,ev)



class GwProxyWidget(QGraphicsProxyWidget, CommonWidget):
	def __init__(self, widget, parent=None):
		QGraphicsProxyWidget.__init__(self, parent)
		self.setWidget(widget)



class GwSpacer(GwWidget):
	def __init__(self, w, h):
		GwWidget.__init__(self)
		self.setMinimumSize(w,h)
		self.setMaximumSize(w,h)
