# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.


from PyQt4.QtCore import *
from PyQt4.QtGui import *

from ..delayedcall import delayedCall


class GwItem(object):
	def __init__(self):
		object.__init__(self)
		
		
	def deleteLater(self):
		delayedCall(1, self.delete)
		
		
	def delete(self):
		if self.scene(): 
			self.scene().removeItem(self)
		


class GwSizedItem(GwItem):
	def __init__(self, w=0, h=0):
		GwItem.__init__(self)
		self._w, self._h = w, h
	
	
	def resize(self, w, h):
		if w==0 or h==0 or (self._w == w and self._h == h):
			return False
		
		self._w, self._h = w, h
		return True
	
	
	def qResize(self, size):
		return self.resize(size.width(),size.height())
	
	
	def size(self):
		return (self._w, self._h)
	
	
	def qSize(self):
		return(QSize(self._w, self._h))
		
		
	def qSizeF(self):
		return(QSizeF(self._w, self._h))
	
	def w(self):
		return self._w
		
	def h(self):
		return self._h 
