# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.


from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtSvg import QSvgRenderer

from os.path import exists

from . import GwSizedItem



#TODO: AUTOMATE CACHE CLEANING!

svgPixCache = {}



def getSvgPixmap(fileName, (w, h)):
	if w==0 or h==0 or not exists(fileName):
		return QPixmap()
		
	if (fileName, w, h) not in svgPixCache.keys():
		#print 'SvgFile(',self.filename,'):pixmapForSize exists'
		svgPixCache[(fileName, w, h)] = newSvgPixmap(fileName, w, h)
		
	return svgPixCache[(fileName, w, h)]
	
	
def newSvgPixmap(fileName, w, h):
	#print 'newSvgPixmap',filename, w, h
	renderer = QSvgRenderer(fileName)
	pixmap = QPixmap(QSize(w,h))
	pixmap.fill(QColor(0,0,0,0))
	
	painter = QPainter(pixmap)
	renderer.render(painter, QRectF(QPointF(0,0), QSizeF(w,h)))
	painter.end()
	
	return pixmap



class GwSvgItem(QGraphicsPixmapItem, GwSizedItem):
	def __init__(self, fileName, w, h, parent=None):
		GwSizedItem.__init__(self)
		QGraphicsPixmapItem.__init__(self, parent)
		self.fileName = fileName
		if GwSizedItem.resize(self, w, h):
			self.setPixmap(getSvgPixmap(fileName, (w, h)))
		
		
	def setFileName(self, fileName):
		if self.fileName == fileName:
			return
		
		self.fileName = fileName
		self.setPixmap(getSvgPixmap(fileName, self.size()))
		
		
	def resize(self, w, h):
		if GwSizedItem.resize(self, w, h):
			self.setPixmap(getSvgPixmap(self.fileName, (w, h)))
		
		
		