# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from generic.widget import GwWidget
from frame import GwFrame
from layout import GwHBoxLayout


class GwTextLabel(GwWidget):
	def __init__(self, text, parent=None):
		GwWidget.__init__(self, parent)
		self.simpleTextItem = QGraphicsSimpleTextItem(self)
		self.setText(text)
		
	def setText(self, text):
		self.simpleTextItem.setText(text)
		self.setMinimumSize(self.simpleTextItem.boundingRect().size())
		#self.setFixedSize(self.simpleTextItem.boundingRect().size())

		self.setMaximumHeight(self.minimumHeight())
	
		
		
class GwFramedTextLabel(GwFrame):
	def __init__(self, text, parent=None):
		GwFrame.__init__(self, parent)
		self.textLabel = GwTextLabel(text, self)
		self.textLabel.setZValue(1)
		GwHBoxLayout(self)
		self.layout().addItem(self.textLabel)
		
	def setText(self, text):
		self.textLabel.setText(text)
		
		
		#self.frame = GwStdFrameItem('frames.svg', prefix='raised-', parent=self)
		##self.frame = FrameSvgItem(chromeFile('frame.svg'), parent=self)
		#self.textitem = QGraphicsSimpleTextItem(text,self.frame)
		
		#self.textitem.setPos(4,2)
		##self.setAcceptDrops(True)
		##self.setMinimumWidth(80)
		#self.setMinimumSize(40,20)
		#self.setMaximumSize(10000,20)
		#self.setPreferredSize(100,20)
		#self.setSizePolicy(QSizePolicy.Preferred,QSizePolicy.Fixed)
		
	##def boundingRect(self):
		##return QRectF(0,0,80,40)
		
	##def dragEnterEvent(self,ev):
		##self.rectitem.setBrush(QBrush(QColor(255,0,0)))
		
	##def dragLeaveEvent(self,ev):
		##self.rectitem.setBrush(QBrush())
		
	#def resizeEvent(self, ev):
		##self.rectitem.setRect(0,0,ev.newSize().width(), ev.newSize().height())
		#self.frame.resize(ev.newSize().width(), ev.newSize().height())