# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from clipbox import GwVClipBox

from layout import GwHBoxLayout

from generic.widget import GwProxyWidget, GwWidget

import traceback, sys

class GwVScrollBox(GwWidget):
	Left = 0
	Right = 1
	
	def __init__(self, scrollPos=Left, parent=None):
		GwWidget.__init__(self, parent)
		self.scrollPos = scrollPos
		self.clipBox = GwVClipBox(self)
		self.clipBox.sizesChangedSig.connect(self.recalcScroll)
		
		self.scrollbar = GwProxyWidget(QScrollBar(Qt.Vertical), self)
		self.scrollbar.widget().valueChanged.connect(self._scroll)
		self.scrollbar.widget().setSingleStep(10)
		self.scrollbar.widget().setMaximum(0)
		self.scrollbar.hide()
		
		#self.clipBox.setMinimumHeight(100)#self.scrollbar.minimumHeight())
		##self.clipBox.setMaximumHeight(self.scrollbar.maximumHeight())
		#self.clipBox.setPreferredHeight(100)#self.scrollbar.preferredHeight())
		
		#print self.clipBox.minimumHeight()
		#print self.clipBox.maximumHeight()
		#print self.clipBox.preferredHeight()
		
		
	def resizeEvent(self,ev):
		self.reLayout()
		
		
	def recalcScroll(self):
		(dw, dh) = self.clipBox.dSize()
		if self.scrollbar.isVisible():
			if dh<=0:
				#print 'hide scroll'
				self.scrollbar.hide() 
				self.scrollbar.widget().setMaximum(0)
				self.clipBox.content.setPos(0,0)
				self.reLayout()
			else:
				self.scrollbar.widget().setPageStep(self.clipBox.size().height())
				self.scrollbar.widget().setMaximum(dh)
				
		elif dh>0:
				#print 'show scroll'
				self.scrollbar.widget().setPageStep(self.clipBox.size().height())
				self.scrollbar.widget().setMaximum(dh)
				self.scrollbar.show()
				self.reLayout()
		
		
	
	def _scroll(self,val):
		self.clipBox.content.setPos(0,-val)
		
		
	def setContent(self,content):
		self.clipBox.setContent(content)
		
		
	def wheelEvent(self, ev):
		#print ev.delta()
		self.scrollbar.widget().setValue(self.scrollbar.widget().value()-int(ev.delta()/12)*2)
		
		
	def reLayout(self):
		if self.scrollbar.isVisible():
			self.scrollbar.resize(self.scrollbar.w(), self.h())
			if self.scrollPos == self.Left:
				self.clipBox.setPos(self.scrollbar.w(), 0)
			else:
				self.scrollbar.setPos(self.w()-self.scrollbar.w(), 0)
			
			self.clipBox.resize(self.w()-self.scrollbar.w(), self.h())
			
		else:
			self.clipBox.setPos(0,0)
			self.clipBox.resize(self.size())
		
	
	def ensureVisible(self, y):
		if not self.scrollbar.isVisible():
			return
		curYoffset = self.clipBox.content.pos().y()
		if y+curYoffset >= 0 and y+curYoffset <= self.clipBox.h():
			return
			
		self.scrollbar.widget().setValue(y)
		
		
	def kineticScrollTo(self, y):
		self.animation = QPropertyAnimation(self.scrollbar.widget(), "value");
		self.animation.setDuration(500);
		self.animation.setEasingCurve(QEasingCurve.OutCubic)
		self.animation.setStartValue(self.scrollbar.widget().value());
		self.animation.setEndValue(y);
		#self.animation.setKeyValueAt(1,self.geometry());
		self.animation.start()
		
	#def itemChange(self,change,val):
		#print 'itemChange',change
		
		#if change == QGraphicsItem.ItemSceneHasChanged:
			#print ' in scene',self.scene()
			#self.clipBox.installSceneEventFilter(self)
			#if self.clipBox.content:
				#self.clipBox.content.installSceneEventFilter(self)
				
		#return QGraphicsWidget.itemChange(self,change,val)
	