# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyKDE4.kdeui import *

from ..pyqgw import *

class TabNameEdit(GwFastLineEdit):
	def __init__(self, text, parent=None):
		GwFastLineEdit.__init__(self, text, parent)
		self.valueChangedSig.connect(self.valueChanged)
		
		
	def mousePressEvent(self, ev):
		if self.textEditItem:
			self.editDone()
		else:
			ev.ignore()
		
		
	def valueChanged(self):
		if self.textEditItem:
			self.setMinimumSize(self.textEditItem.boundingRect().size())
		#else:
			#self.setMinimumSize(self.textEditItem.boundingRect().size())
		
	def startEdit(self):
		GwFastLineEdit.startEdit(self)
		self.textEditItem.mousePressedSig.connect(self.editDone)
		
	
	#def mouseReleaseEvent(self, ev):
		#ev.ignore()
		
	
class Tab(GwFrame):
	clickedSig = pyqtSignal(str)
	delClickedSig = pyqtSignal(str)
	
	def __init__(self, tabName):
		GwFrame.__init__(self)
		self.setFlag(QGraphicsItem.ItemIgnoresParentOpacity)
		self.setMinimumHeight(20)
		#self.setMinimumWidth(500)
		
		self.setAcceptHoverEvents(True)
		
		self.tabName = tabName
		
		self.delButton = GwPushButton(icon=GwIconItem(KIcon("dialog-close"),16,16), parent=self)
		self.delButton.clicked.connect(self.delClicked)
		self.delButton.setFlag(QGraphicsItem.ItemIgnoresParentOpacity)
		self.delButton.setPos(-25,0)
		self.delButton.hide()
		
		self.tabNameEdit = TabNameEdit(tabName)
		self.tabNameEdit.setZValue(1)
		#self.setFlag(QGraphicsItem.ItemDoesntPropagateOpacityToChildren)
		self.tabNameEdit.setFlag(QGraphicsItem.ItemIgnoresParentOpacity)
		
		self.setLayout(GwHBoxLayout())
		self.layout().addItem(self.tabNameEdit)
		
		#self.setAutoFillBackground(True)
		
		#self.state = 'inactive'
		
		#pal = self.palette()
		#pal.setColor(QPalette.Window, QColor(255,255,255))
		
		#self.statePalette = {
				#'inactive': self.palette(),
				#'active': self.palette()
				##'hovered': self.palette()
			#}
			
		#self.statePalette['inactive'].setColor(QPalette.Window, QColor(255,255,255))
		#self.statePalette['active'].setColor(QPalette.Window, QColor(255,255,255))
		#self.statePalette['hovered'].setColor(QPalette.Window, QColor(255,255,255))
		
		self.setOpacity(0.7)
		
		self.active = False
		
		
	def delClicked(self):
		self.delClickedSig.emit(self.tabName)
		
		
	def hoverEnterEvent(self, ev):
		#palette = self.palette()
		#palette.setColor(QPalette.Window, QColor(255,0,0))
		#self.setPalette(palette)
		if not self.active:
			self.setFrameStyle('white','raised')
		
		self.setOpacity(0.9)
		
		
	def hoverLeaveEvent(self, ev):
		#palette = self.palette()
		#palette.setColor(QPalette.Window, QColor(255,0,0))
		#self.setPalette(qApp.palette())
		if not self.active:
			#self.setFrameStyle('active')
			#else:
			self.setFrameStyle('white','plain')
			
		self.setOpacity(0.7)
		
		
	def mousePressEvent(self, ev):
		#self.setPalette(self.statePalette['active'])
		self.clickedSig.emit(self.tabName)
		
		
	def mouseDoubleClickEvent(self,ev):
		self.tabNameEdit.selectAll()
		
	
	def activate(self):
		self.active = True
		self.setFrameStyle('white','active')
		
	def deactivate(self):
		self.active = False
		self.setFrameStyle('white','plain')
		
	def showDelButton(self):
		pass
 
