# -*- coding: utf-8 -*-

# This file is part of NExp. NExp is a tool for exploring Nepomuk database.

# Copyright (C) 2010  Evstifeev Roman <someuniquename@gmail.com>

# NExp is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# NExp is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with NExp.  If not, see <http://www.gnu.org/licenses/>.


from PyKDE4.soprano import Soprano


prefixDict = {}

#for nsName, ns  in Soprano.Vocabulary.__dict__.iteritems():
	#if nsName[:2] == '__':
		#continue #ignore
	#for methodName in ns.__dict__:
		#if methodName[-9:] == 'Namespace':
			#method = getattr(ns, methodName)
			#nsPrefix = method().toString()
			#if nsPrefix[-1] == '#':
				#prefixDict[nsName] = nsPrefix[:-1]
				#print nsName, prefixDict[nsName]
				
prefixDict['rdf'] =  'http://www.w3.org/1999/02/22-rdf-syntax-ns'
prefixDict['rdfs'] =  'http://www.w3.org/2000/01/rdf-schema'

prefixDict['nrl'] =  'http://www.semanticdesktop.org/ontologies/2007/08/15/nrl'
prefixDict['nao'] =  'http://www.semanticdesktop.org/ontologies/2007/08/15/nao'
prefixDict['nie'] = 'http://www.semanticdesktop.org/ontologies/2007/01/19/nie'
prefixDict['nfo'] = 'http://www.semanticdesktop.org/ontologies/2007/03/22/nfo'
prefixDict['nid3'] = 'http://www.semanticdesktop.org/ontologies/2007/05/10/nid3'
prefixDict['nmm'] = 'http://www.semanticdesktop.org/ontologies/2009/02/19/nmm'
prefixDict['nso'] = 'http://www.semanticdesktop.org/ontologies/2009/11/08/nso'
prefixDict['nexif'] = 'http://www.semanticdesktop.org/ontologies/2007/05/10/nexif'
prefixDict['nmo'] = 'http://www.semanticdesktop.org/ontologies/2007/03/22/nmo'
prefixDict['nco'] = 'http://www.semanticdesktop.org/ontologies/2007/03/22/nco'
prefixDict['tmo'] = 'http://www.semanticdesktop.org/ontologies/2008/05/20/tmo'
prefixDict['ncal'] = 'http://www.semanticdesktop.org/ontologies/2007/04/02/ncal'
prefixDict['pimo'] = 'http://www.semanticdesktop.org/ontologies/2007/11/01/pimo'

prefixDict['XMLSchema'] =  'http://www.w3.org/2001/XMLSchema'
prefixDict['Xesam'] =  'http://freedesktop.org/standards/xesam/1.0/core'
prefixDict['owl'] =  'http://www.w3.org/2002/07/owl'
prefixDict['SIL'] =  'http://soprano.org/sil'


def qName(url):
	urlstr = unicode(url)
	for (short, full) in prefixDict.iteritems():
		#print urlstr, short, urlstr.find(full)
		if ( urlstr.startswith(full+'#')
		or   urlstr.startswith('<'+full+'#')):
			return urlstr.replace(full+'#', short+':')
		elif ( urlstr == full
		or     urlstr == '<'+full+'>'):
			return urlstr.replace(full, short)
	return urlstr
	
	
def fullName(url):
	urlstr = unicode(url)
	for (short, full) in prefixDict.iteritems():
		if ( urlstr.startswith(short+':') 
		or   urlstr.startswith('<'+short+':')):
			return urlstr.replace(short+':', full+'#')
		elif ( urlstr == short
		or     urlstr == '<'+short+'>'):
			return urlstr.replace(short, full)
	return urlstr
	
#def shortenUrl(full):
	#for short, full in prefixDict.iteritems():
		#if url.startsWith(full):
			#return url.replace(full, short)
	#return url
	
#def shortenUrl(inputStr):
	#if inputStr.type not in [str, QString]:
		#raise Exception('input argument supposed to be str or QString')
	
	#for (short, full) in prefixDict.iteritems():
		#if inputStr.type == str and inputStr.startswith(full):
			#return url.replace(full, short)
		#esle if inputStr.startsWith(full):
			#return url.replace(full, short)
	#return url
	
	
class Statement:
	def __init__(self, s):
		self.context = unicode(s.context().toString())
		self.subject = unicode(s.subject().toString())
		self.predicate = unicode(s.predicate().toString())
		self.object = unicode(s.object().toString())
		
		
class StatementsDict(dict):
	def __init__(self):
		dict.__init__(self)
	
	def addStatement(self, statement):
		s = Statement(statement)
		if s.context not in self: 
			self[s.context] = {}
		subjects = self[s.context]
		if s.subject not in subjects: 
			subjects[s.subject] = {}
		predicates = subjects[s.subject]
		if s.predicate not in predicates: 
			predicates[s.predicate] = []
		objects = predicates[s.predicate]
		objects.append(s.object)
		